/*
 * Grille1D.cpp
 *
 *  Created on: 13 nov. 2009
 *      Author: Anya
 */

#include "Grille1D.h"


Grille1D::Grille1D(double borneInf, double borneSup, double pas)
{
	/*
	 * Ce premier constructeur permet de dfinir une grille  sur un intervalle
	 * [a,b] en prcisant le pas d'chantillonnage
	 * le nombre de points en sera dduit
	 */
	a=borneInf;  // attribution des valeurs aux attributs
	b=borneSup;
	h=pas;
	nbPoints=(int)floor((b-a)/h)+1; // calcul de nombre de poins tant donn le pas
	
	//floor partie entiere d'un reel
	/*
	  *  par dfaut le vecteur est initialis  un vecteur vide
	  *  avant de le remplir, il faut rserver la place en mmoire
	  *  ncessaire pour stocker les points de la grille
	  *  Pour la classe vector cela se fait  l'aide de la mthode resize()
	  *  voir le sdtails dans la rfrence de la classe vector
	  */
	pointsX.resize(nbPoints);


	/*
	 * Calcul des points de la grille
	 */

	for(int i=0;i<nbPoints;i++)
	{
		pointsX[i]=a+i*h;
	}
}
Grille1D::Grille1D(double borneInf, double borneSup, int nb)
{
	/*
	 * il est possible en C++  de dfinir plusieurs constructeurs pour la mme classe.
	 * Il s'agit ici d'un cas de surcharge de mthode
	 * les diffrentes mthodes portant le mme nom doivent ncessairement avoir les listes d'arguments diffrentes
	 *
		 * Ce deuxime constructeur permet de dfinir une grille  sur un intervalle
		 * [a,b] en prcisant le nombre de points voulu
		 * le pas d'chntillonnage  en sera dduit
		 */
	a=borneInf;
		b=borneSup;
		h=(b-a)/(nb-1); // calcul du pas d'chantillonnage  partir du nombre de points (bornes comprises)
		nbPoints=nb;
		pointsX.resize(nbPoints);//on rserve de la mmoir pour stocker le spoints de la grille
		for(int i=0;i<nbPoints;i++)
		{
			pointsX[i]=a+i*h;     // calcul de spoints de la grille
		}
}

/*
 * suivent les mthodes d'accs aux attributs privs
 */
	 double Grille1D::getA()
	 {
	 	return a;
	 }
	 double Grille1D::detB()
	 {
	 	return b;
	 }
	 vector<double> Grille1D::getPoints()
	 {
	 	return pointsX;
	 }
	 int Grille1D::getNbPoints()
	 {
	 	return nbPoints;
	 }

/*
 * destructeur minimal de la classe
 */
Grille1D::~Grille1D() {
	// TODO Auto-generated destructor stub
}
