/*
 * MatriceTriDiagonale.cpp
 *
 *  Created on: 8 dc. 2009
 *      Author: Anya
 */

#include "MatriceTriDiagonale.h"


MatriceTriDiagonale::MatriceTriDiagonale() {
	// TODO Auto-generated constructor stub

}



MatriceTriDiagonale::MatriceTriDiagonale(int n )
{
	/*
	 * Constructeur lmentaire   partir de la donne de la dimension
	 * e
	 */
	dim=n;
	/*
	 * Important! Il faut d'abord rserver la mmoire ncessaire avant
	 * d'affecteur par copie un vecteur
	 *
	 */
	diagCentral.resize(n);
	diagL.resize(n-1);
	diagU.resize(n-1);

}



MatriceTriDiagonale::MatriceTriDiagonale(int n,valarray<double> C, valarray<double> L, valarray<double> U)
{
	/*
	 * Constructeur principal  partir de la donne de la dimension
	 * et des trois diagonales
	 */
	dim=n;
	if(C.size() != n | L.size() != n-1 | U.size() != n-1)
	{   // vrification de la conformit des dimensions
		cout<<"erreur: les dimnsions  sont incopatibles!\n";
	}
	else
	{
		/*
		 * Important! Il faut d'abord rserver la mmoire ncessaire avant
		 * d'affecteur par copie un vecteur
		 *
		 */
		diagCentral.resize(n);
		diagL.resize(n-1);
		diagU.resize(n-1);

		diagCentral=C;
		diagL=L;
		diagU=U;


	}
}

MatriceTriDiagonale::MatriceTriDiagonale(  vector< vector<double> > M)
{
	/*
	 * Constructeur  partir d'une matrice pleine
	 * Permet d'extraire les trois diagonales principales de la matrice M
	 * dans une nouvelle matrice tri-diagonale
	 *
	 */

	// rcupration de la dimension
	dim=M.size();
	// allocation de mmoire pour les trois diagonales

	diagCentral.resize(dim);
	diagL.resize(dim-1);
	diagU.resize(dim-1);

	//copie des lments de la matrcie M
	for(int i=1;i<dim-1;i++)
	{
		diagCentral[i]=M[i][i];
		diagL[i-1]=M[i][i-1];
		diagU[i]=M[i][i+1];
	}
	diagCentral[0]=M[0][0];
	diagL[dim-2]=M[dim-1][dim-2];
	diagU[0]=M[0][1];
	diagCentral[dim-1]=M[dim-1][dim-1];

}



valarray<double>  MatriceTriDiagonale::getDiagCentral()
{
	/*
	 * mthode d'accs  la diagonale centrale
	 */
	return diagCentral;

}

valarray<double>  MatriceTriDiagonale::getDiagL()
{
	/*
	 * mthode d'accs  la diagonale  sous la centrale
	 */
	return diagL;

}

valarray<double>  MatriceTriDiagonale::getDiagU()
{
	/*
	 * mthode d'accs  la diagonale au-dessus de la centrale
	 */
	return diagU;
}


int  MatriceTriDiagonale::getDim()
{
	/*
	 * mthode d'accs  la dimension
	 */
	return dim;
}


void  MatriceTriDiagonale::afficher(){


	/*
	 * Affiche sur console la matrice ligne par ligne
	 * A utiliser avec des petites matrices! enutilisant la surcharge de []
	 */

}

MatriceTriDiagonale   MatriceTriDiagonale::operator +(MatriceTriDiagonale A)
{
	if(A.getDim()!=dim)
	{

		Except_matrice err("dimensions incompatibles!");
	}
	else{

		valarray<double> C(dim);
		valarray<double> L(dim-1);
		valarray<double> U(dim-1);

		C=diagCentral+A.getDiagCentral();
		L=diagL+A.getDiagL();
		U=diagU+A.getDiagU();
		// on cre la nouvelle matrice  et on la revoie
		MatriceTriDiagonale M(dim,C,L,U);
		return M;
	}

}

valarray<double> MatriceTriDiagonale::operator *(valarray<double> y)
{
	valarray<double> C(dim);
	valarray<double> L(dim-1);
	valarray<double> U(dim-1):

	C=diagCentral * A.getDiagCentral();
	L=diagL * A.getDiagL();
	U=diagU * A.getDiagU();

	MatriceTriDiagonale M(dim,C,L,U);
	returnM;
}

valarray<double>  MatriceTriDiagonale::operator [](int i)
{
    if (i>=dim | i<0)
    {
        Except_matrice e("le numro de ligne est invalide \n");
        throw e;
    }
    else
    {
	valarray<double> ligne(0,dim);
	if (i==0)
	{
       ligne[0]=diagCentral[0];
       ligne[i]=diagU[0];
    }
    else
    {
       if(i==n-1)
       {
           ligne[n-2]=diagL[n-2];
           ligne[n-1]=diagCentral[n-1];
       }
       else
       {
           ligne[i]=diagCentrale[i];
           ligne[i-1]=diagL[i-1];
           ligne[i+1]=diagU[i];
       }
    }
    } return ligne
}

double & MatriceTriDiagonale::operator ()(int i,int j)
{
	if(i<0 | j<0 | i>=n | j>=n)
	{
           Except_matrice e("indice invalide \n");
	       throw e;
    }
    else
    {
         if (abs(i-j)>1)
         {
                        Except_matrice e("accs interdit aux lments hors diagonale \n");
                        throw e;
         }
         else
         {
             if (i==j) return diagCentral[i];
             if (i>j) return diagL[j];
             if (i<j) return diagU[i];
         }
    }
}


void  MatriceTriDiagonale:: Thomas(valarray<double> y, valarray<double> *x)
{
		valarray<<double>> beta;
		valarray<<double>> gamma;

		beta[1] = diagCentral[1];
		gamma[1]= y[1]/diagCentral[1];

        for (int k=2, k < dim, k++) {
            beta[k] = diagCentral[k] - (diagU[k-1]/diagCentral[k-1]) * diagL[k];
            gamma[k] = (y[k] - diagU[k] * gamma[k-1])/beta[k];
		}
}

MatriceTriDiagonale::~MatriceTriDiagonale() {
	// TODO Auto-generated destructor stub
}
